<?php
namespace Pinpoint\CustomPriceRulesExport\Model;

use Magento\SalesRule\Model\ResourceModel\Rule\CollectionFactory as RuleCollectionFactory;

class Exporter
{
    protected $ruleCollectionFactory;

    public function __construct(RuleCollectionFactory $ruleCollectionFactory)
    {
        $this->ruleCollectionFactory = $ruleCollectionFactory;
    }

    public function getExportData()
    {
        $data = [];

        // Fetch price cart rules
        $rules = $this->ruleCollectionFactory->create();

        foreach ($rules as $rule) {
            // Format rule data as needed
            $data[] = [
                'rule_id' => $rule->getId(),
                'name' => $rule->getName(),
                'description' => $rule->getDescription(),
                // Add more fields as needed
            ];
        }

        // Generate CSV content
        $csvContent = $this->generateCsvContent($data);

        return $csvContent;
    }

    protected function generateCsvContent($data)
    {
        $output = fopen('php://temp', 'w');
        fputcsv($output, array_keys(reset($data))); // CSV header

        foreach ($data as $row) {
            fputcsv($output, $row);
        }

        rewind($output);
        $csvContent = stream_get_contents($output);
        fclose($output);

        return $csvContent;
    }
}
